
var LOGFILE_NAME = "actionhandler.log";
var l = new Logger(LOGFILE_NAME);

var lActionDurationZoneScene=500;
var lActionDurationDeviceScene=500;
var lActionDurationDeviceValue=500;
var lActionDurationDeviceBlink=500;
var lActionDurationZoneBlink=500;
var lActionDurationCustomEvent=500;
var lActionDurationUrl=500;


function getStates() {
	return [];
}

function checkCondition(pathToDescription)
{
	var oBaseConditionNode=Property.getNode(pathToDescription+'/conditions');
	if (oBaseConditionNode!=null)
	{
		var oEnabledNode=oBaseConditionNode.getChild('enabled');
		if (oEnabledNode!=null)
			if (oEnabledNode.getValue()==false)
				return false;
		var oStateNode=oBaseConditionNode.getChild('states');
		if (oStateNode!=null) {
			var oStateArrayActual=getStates();
			var oStateArrayCondition=oStateNode.getChildren();
			for (var iIndex=0;iIndex<oStateArrayCondition.length;iIndex++)			 // check only for requested state, other ignored
			{
				var fFound=false;
				for (var jIndex=0;jIndex<oStateArrayActual.length;jIndex++) {
					if (oStateArrayCondition[iIndex].getName()==oStateArrayActual) { // search for a requested state
						fFound=true;												 // state found ...
						if (oStateArrayCondition[iIndex].getValue()==false) {        // ..., but was requested as not set -> condition failed
							return false;  
						}						
					}
				}
				if (oStateArrayCondition[iIndex].getValue()==true)					 // state was requested as active
					if (fFound==false)												 // but not found -> condition failed  
						return false;
			}
		}
		var oWeekdayNode=oBaseConditionNode.getChild('weekdays');
		if (oWeekdayNode!=null) {
			var sWeekdayString=oWeekdayNode.getValue();
			if (sWeekdayString!=null)
			{
				var oNow=new Date();
				var oWeekDayArray=sWeekdayString.split(",");
				var fFound=false;
				for (var iIndex=0;iIndex<oWeekDayArray.length;iIndex++)
					if (parseInt(oWeekDayArray[iIndex])==oNow.getDay())
						fFound=true;
				if (fFound==false)
					return false;
			}
		}
		var oTimeStartNode=oBaseConditionNode.getChild('time-start');
		if (oTimeStartNode!=null) 
		{
			var sTime=oTimeStartNode.getValue();
			var oTimeTemp=sTime.split(':');
			if (oTimeTemp.length==3)
			{
				var secondsSinceMidnightCondition=(parseInt(oTimeTemp[0]) * 3600) + (parseInt(oTimeTemp[1]) * 60) +  parseInt(oTimeTemp[0]);
				var oNow=new Date();
				var secondsSinceMidnightNow=(oNow.getHours() * 3600) + (oNow.getMinutes() * 3600) + (oNow.getSecounds());
				if (!(secondsSinceMidnightCondition<= secondsSinceMidnightNow))
					return false;
			}
		}
		var oTimeEndNode=oBaseConditionNode.getChild('time-end');
		if (oTimeEndNode!=null)
		{
			var sTime=oTimeEndNode.getValue();
			var oTimeTemp=sTime.split(':');
			if (oTimeTemp.length==3)
			{
				var secondsSinceMidnightCondition=(parseInt(oTimeTemp[0]) * 3600) + (parseInt(oTimeTemp[1]) * 60) +  parseInt(oTimeTemp[0]);
				var oNow=new Date();
				var secondsSinceMidnightNow=(oNow.getHours() * 3600) + (oNow.getMinutes() * 3600) + (oNow.getSecounds());
				if (!(secondsSinceMidnightNow<= secondsSinceMidnightCondition))
					return false;
			}
		}
	}	
	return true;
}

function executeZoneScene(oActionNode)
{
	l.logln('executeZoneScene ' + oActionNode.getPath() );
	var target = getDevices();						

	var oZoneNode=oActionNode.getChild("zone");						
	if (oZoneNode!=null) {
	
		target=target.byZone(oZoneNode.getValue());							
		if (target!=null) {
			
			var oGroupNode=oActionNode.getChild("group");							
			if (oGroupNode!=null) {
				target=target.byGroup(oGroupNode.getValue());
				if (target!=null) {
					
					var oSceneNode=oActionNode.getChild("scene");
					if (oSceneNode!=null) {
						var oForceNode=oActionNode.getChild("force");	
						var iSceneID=oSceneNode.getValue();						
						var fForce=false;
						
						if (oForceNode!=null)
							fForce=oForceNode.getValue();
						l.logln('zone-scene : force is ' + fForce);
						if (fForce==true) 
							target.callScene(iSceneID,true);
						else
							target.callScene(iSceneID);
						
					} else {
						l.logln('zone-scene : missing "scene" - node');
					}
				} else {
					l.logln('zone-scene : target=target.byGroup(oGroupNode.getValue()); is null');
				}
			} else {
				l.logln('zone-scene : missing "group" - node');
			}					
		} else {
			l.logln('zone-scene : target.byZone(oZoneNode.getValue()) is null');
		}
	} else {
		l.logln('zone-scene : missing "zone" - node');
	}						
}
function executeDeviceScene(oActionNode)
{
	l.logln('executeDeviceScene ' + oActionNode.getPath() );
	var oDeviceNode=oActionNode.getChild("dsid");
	if (oDeviceNode!=null) {
		var target=getDevices().byDSID(oDeviceNode.getValue());
		if (target!=null)
		{
			var oSceneNode=oActionNode.getChild("scene");
			if (oSceneNode!=null) {
				var oForceNode=oActionNode.getChild("force");	
				var iSceneID=oSceneNode.getValue();						
				var fForce=false;
				if (oForceNode!=null)
					oForceNode.getValue();
				
				if (fForce==true) 
					target.callScene(iSceneID,true);
				else
					target.callScene(iSceneID);
			}														
		}							
	}
}
function executeDeviceValue(oActionNode)
{
	l.logln('executeDeviceValue ' + oActionNode.getPath() );
	var oDeviceNode=oActionNode.getChild("dsid");
	if (oDeviceNode!=null) {
		var target=getDevices().byDSID(oDeviceNode.getValue());
		if (target!=null)
		{
			var oValueNode=oActionNode.getChild("value");
			if (oValueNode!=null) {
				target.setValue(oValueNode.getValue());
			}
		}							
	}
}
function executeDeviceBlink(oActionNode)
{
	l.logln('executeDeviceBlink ' + oActionNode.getPath() );
	var oDeviceNode=oActionNode.getChild("dsid");
	if (oDeviceNode!=null) {
		var target=getDevices().byDSID(oDeviceNode.getValue());
		if (target!=null)
		{
			target.blink();
		}							
	}
}
function executeZoneBlink(oActionNode)
{
	l.logln('executeZoneBlink ' + oActionNode.getPath() );	
	var target = getDevices();						

	var oZoneNode=oActionNode.getChild("zone");						
	if (oZoneNode!=null) {
	
		target=target.byZone(oZoneNode.getValue());							
		if (target!=null) {
			
			var oGroupNode=oActionNode.getChild("group");							
			if (oGroupNode!=null) {
				target=target.byGroup(oGroupNode.getValue());
				if (target!=null) {
					target.blink();
				}
			}
		}
	}
}
function executeCustomEvent(oActionNode)
{
	l.logln('executeCustomEvent ' + oActionNode.getPath() );
	var oEventNode=oActionNode.getChild("event");
	var evt = new Event("highlevelevent",{name:oEventNode.getValue()});			
	evt.raise();
}
function executeUrl(oActionNode)
{
	l.logln('executeUrl ' + oActionNode.getPath() );
	var oUrlNode=oActionNode.getChild("url");
}

function execute(pathToDescription)
{	
	var iValue=new Date().getTime();
	Property.setProperty(pathToDescription + '/lastExecuted',""+iValue)
	l.logln('Execute Path ' + pathToDescription);
	var oBaseActionNode=Property.getNode(pathToDescription+'/actions');	
	if (oBaseActionNode==null) {
		l.logln('no actionNodes in Path ' + pathToDescription+'/actions');
		return;		
	}	
	var oArrayActions=oBaseActionNode.getChildren();
	if (oArrayActions==null) {
		l.logln('no subnodes in Path ' + pathToDescription+'/actions');
		return;		
	}
	if (oArrayActions.length==0) {
		l.logln('subnode count=0 in Path ' + pathToDescription+'/actions');
		return;		
	}
	executeStep(oArrayActions);
}

function executeStep(oActionArray)
{
	var oActionNode=oActionArray[0];
	var lWaitingTime=1;
	if (oActionNode!=null) {
		lWaitingTime=executeOne(oActionNode);
	} else {
		l.logln('action node is null ');
	}
	if (oActionArray.length>1) {
		oActionArray.shift();
		l.logln('Nextaction in ' + lWaitingTime);
		callNextAction = function () { 
			executeStep(oActionArray); 
		};
		setTimeout(callNextAction, lWaitingTime);
	}
}

function executeOne(oActionNode)
{
	l.logln('Execute actionnode ' + oActionNode.getPath());
	if (checkCondition(oActionNode.getPath())) {
		var oTypeNode=oActionNode.getChild("type");
		if (oTypeNode!=null) {
			var sActionType=oTypeNode.getValue();
			if (sActionType!=null)
			{
				l.logln('type is ' + sActionType + "!");
				if (sActionType=='zone-scene') {
					executeZoneScene(oActionNode);
					return lActionDurationZoneScene;
				} else
				if (sActionType=='device-scene') {
					executeDeviceScene(oActionNode);
					return lActionDurationDeviceScene;
				} else
				if (sActionType=='device-value') {
					executeDeviceValue(oActionNode);
					return lActionDurationDeviceValue;
				} else
				if (sActionType=='device-blink') {
					executeDeviceBlink(oActionNode);
					return lActionDurationDeviceBlink;
				} else
				if (sActionType=='zone-blink') {
					executeZoneBlink(oActionNode);
					return lActionDurationZoneBlink;
				} else
				if (sActionType=='custom-event') {
					executeCustomEvent(oActionNode);
					return lActionDurationCustomEvent;
				} else
				if (sActionType=='url') {
					executeUrl(oActionNode);
					return lActionDurationUrl;
				}
			} else {
				l.logln('value of typenode is null');
			}
		} else {
			l.logln('No typenode in ' + oActionNode.getPath());
		}
	} else {
		l.logln('Conditions failed ' + oActionNode.getPath());
	}
	return 0;
}

function getPath(name)
{
	var baseNode = Property.getNode('/usr/events');
	if (baseNode==null)
		return null;
	var aBaseArray=baseNode.getChildren();
	if (aBaseArray==null)
		return null;
	for (var iIndex=0;iIndex<aBaseArray.length;iIndex++)
	{
		var oNameNode=aBaseArray[iIndex].getChild('name');
		if (oNameNode.getValue()==name)
			return aBaseArray[iIndex].getPath();
	}
	return null;
}

l.logln('Event: ' + raisedEvent.name);
for (var oKey in raisedEvent.parameter) 	
{
	l.logln('Parameter: ' + oKey + ' : ' + raisedEvent.parameter[oKey]);
}

if (raisedEvent.name == 'highlevelevent') {
	if (raisedEvent.parameter.name!=null) {
		var sPath=getPath(unescape(raisedEvent.parameter.name));
		if (sPath!=null)
			execute(sPath);
		else
			l.logln('Event not found');
	}				
}
