var LOGFILE_NAME = "hleconfig.log";
var l = new Logger(LOGFILE_NAME);
var fLocalCopy=true;

function storeSubParameter(path,value)
{
	Property.setProperty('/usr/events/' + path, value);
	Property.setFlag('/usr/events/' + path, 'ARCHIVE', true);
	Property.setProperty('/usr/events/' + path, value);
	if (fLocalCopy) {
		Property.setProperty('/scripts/hle-config/' + path, value);
		Property.setFlag('/scripts/hle-config/'+ path, 'ARCHIVE', true);
	}
}

function restoreFromBackup()
{
	var baseNode = Property.getNode('/usr/');
	if (baseNode!=null)
		Property.removeChild('events');
	var baseNodes = Property.getNode('/scripts/hle-config');
	if (baseNodes==null) {
		return;
	}
	
	var ffLocalCopy=fLocalCopy;
	fLocalCopy=false;
	for (var iIndex=0;iIndex<baseNodes.getChildren().length;iIndex++)
	{
		l.logln('restore node ' + iIndex);
		try {
			var nameNode=baseNodes.getChildren()[iIndex].getChild('name');
			if (nameNode!=null) {
				var name=nameNode.getValue();
				var esName=escape(name);
				storeSubParameter( esName	+ '/name', name);
				storeSubParameter( esName	+ '/disabled', baseNodes.getChildren()[iIndex].getChild('disabled').getValue());
				storeSubParameter( esName	+ '/lastSaved', baseNodes.getChildren()[iIndex].getChild('lastSaved').getValue());
				for (var jIndex=0;jIndex<baseNodes.getChildren()[iIndex].getChild('actions').getChildren().length;jIndex++)			
				{
					l.logln('restore subnode: ' + jIndex);
					var oSubobject=baseNodes.getChildren()[iIndex].getChild('actions').getChildren()[jIndex];
					storeSubParameter( esName + '/actions/' + jIndex + '/type', oSubobject.getChild('type').getValue());
					switch(oSubobject.getChild('type').getValue())
					{
						case 'zone-scene':
							storeSubParameter( esName + '/actions/' + jIndex + '/zone', oSubobject.getChild('zone').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/group', oSubobject.getChild('group').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/scene', oSubobject.getChild('scene').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/force', oSubobject.getChild('force').getValue());
						break;
						case 'device-scene':
							storeSubParameter( esName + '/actions/' + jIndex + '/dsid', oSubobject.getChild('dsid').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/scene', oSubobject.getChild('scene').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/force', oSubobject.getChild('force').getValue());
						break;
						case 'device-value':
							storeSubParameter( esName + '/actions/' + jIndex + '/value', oSubobject.getChild('value').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/dsid', oSubobject.getChild('dsid').getValue());
						break;
						case 'device-blink':
							storeSubParameter( esName + '/actions/' + jIndex + '/dsid', oSubobject.getChild('dsid').getValue());
						break;
						case 'zone-blink':
							storeSubParameter( esName + '/actions/' + jIndex + '/zone', oSubobject.getChild('zone').getValue());
							storeSubParameter( esName + '/actions/' + jIndex + '/group', oSubobject.getChild('group').getValue());
						break;
						case 'custom-event':
							storeSubParameter( esName + '/actions/' + jIndex + '/event', oSubobject.getChild('event').getValue());
						break;
						case 'url':
							storeSubParameter( esName + '/actions/' + jIndex + '/url', oSubobject.getChild('url').getValue());
						break;
					}
				}		
			}
		} 
		catch (e)
		{
			l.logln("Fehler beim RestoreFROMBackup" + iIndex + " : " + e);
			fLocalCopy=ffLocalCopy;
		}
	}
	fLocalCopy=ffLocalCopy;
}

function storeValue(sParameterString)
{
	try
	{
		var oParameterObject=JSON.parse(unescape(sParameterString));
		var esName=escape(oParameterObject.name);
		
		var baseNode = Property.getNode('/usr/events/');
		if (baseNode!=null)
			Property.removeChild(esName);

		storeSubParameter( esName + '/name', oParameterObject.name);
		storeSubParameter( esName + '/disabled', false);
		var iValue=new Date().getTime();
		storeSubParameter( esName + '/lastSaved', ""+iValue );
		for (var iIndex=0;iIndex<oParameterObject.actions.length;iIndex++)
		{
			var oSubobject=oParameterObject.actions[iIndex];
			storeSubParameter( esName	+ '/actions/' + iIndex + '/type', oSubobject.type);
			switch(oSubobject.type)
			{
				case 'zone-scene':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/zone', oSubobject.zone);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/group', oSubobject.group);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/scene', oSubobject.scene);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/force', oSubobject.force);
				break;
				case 'device-scene':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/dsid', oSubobject.dsid);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/scene', oSubobject.scene);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/force', oSubobject.force);
				break;
				case 'device-value':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/value', oSubobject.value);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/dsid', oSubobject.dsid);
				break;
				case 'device-blink':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/dsid', oSubobject.dsid);
				break;
				case 'zone-blink':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/zone', oSubobject.zone);
					storeSubParameter( esName	+ '/actions/' + iIndex + '/group', oSubobject.group);
				break;
				case 'custom-event':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/event', oSubobject.event);
				break;
				case 'url':
					storeSubParameter( esName	+ '/actions/' + iIndex + '/url', oSubobject.url);
				break;
			}
		}
		Property.store();
	}
	catch(e)
	{
		l.logln("Fehler beim Speichern: " + e);
	}
}

l.logln("HLE-Config " + raisedEvent.name);
if (raisedEvent.name == 'hle-config') {
	l.logln("HLE-Config param action " + raisedEvent.parameter.actions);
	if (raisedEvent.parameter.actions=='save')
	{
		l.logln("HLE-Config param value " + raisedEvent.parameter.value);		
		storeValue(raisedEvent.parameter.value);
		Property.store();
		var evt = new Event("hle-saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='enable')
	{
		l.logln("HLE-Config enable value " + raisedEvent.parameter.name);		
		storeSubParameter( raisedEvent.parameter.name	+ '/disabled', false);
		var iValue=new Date().getTime();
		storeSubParameter( raisedEvent.parameter.name + '/lastSaved', ""+iValue );
		Property.store();
		var evt = new Event("hle-saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='disable')
	{
		l.logln("HLE-Config disable value " + raisedEvent.parameter.name);		
		storeSubParameter( raisedEvent.parameter.name	+ '/disabled', true);
		var iValue=new Date().getTime();
		storeSubParameter( raisedEvent.parameter.name + '/lastSaved', ""+iValue );
		Property.store();
		var evt = new Event("hle-saved",{});			
		evt.raise();
	}	
	if (raisedEvent.parameter.actions=='delete')
	{
		l.logln("HLE-Config delete value " + raisedEvent.parameter.name);		
		
		var baseNode = Property.getNode('/usr/events');
		if (baseNode!=null)
			baseNode.removeChild( raisedEvent.parameter.name);
		baseNode = Property.getNode('/scripts/hle-config');
		if (baseNode!=null)
			baseNode.removeChild( raisedEvent.parameter.name);		
		Property.store();
		var evt = new Event("hle-saved",{});			
		evt.raise();
	}	
	if (raisedEvent.parameter.actions=='restore')
	{		
		Property.load();
		restoreFromBackup();
		var evt = new Event("hle-saved",{});			
		evt.raise();
	}
}
else if (raisedEvent.name == 'running') {
	Property.load();
	restoreFromBackup();
}
